/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2014 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: kernel_int.h 345 2014-09-16 23:55:32Z fsi-dankei $
 */

/*
 *		Os_Lcfg.cʤcfg1_out.cѥإåե
 */

#ifndef TOPPERS_KERNEL_INT_H
#define TOPPERS_KERNEL_INT_H

/*
 *  ͥɸإåե
 */
#include "kernel_impl.h"

/*
 *  ͥγƥإåե
 */
#include "task.h"
#include "counter.h"
#include "alarm.h"
#include "interrupt.h"
#include "resource.h"
#include "scheduletable.h"
#include "memory.h"
#include "spinlock.h"
#include "ioc_impl.h"

/*
 *  ᥤ롼̾ѤΥޥ
 */
#define TASKNAME(TaskName)	TaskMain ## TaskName
#define ISRNAME(ISRName)	ISRMain  ## ISRName
#define ICISRNAME(ICIName)	ICIMain  ## ICIName

/*
 *  ֥Ȥ°ʥե졼եǤΤ߻ѡ
 */

/*
 *  ٥ȥޥ
 */
#define AUTO		UINT_C(0x00)    /* ٥ȥޥ=AUTO */

#define TA_NOWRITE		UINT_C(0x01)    /* ߥػ */
#define TA_NOREAD		UINT_C(0x02)    /* ɽФػ */
#define TA_EXEC			UINT_C(0x04)    /* ¹ԥ */
#define TA_MEMINI		UINT_C(0x08)    /* νԤ */
#define TA_MEMPRSV		UINT_C(0x10)    /* νԤʤ */
#define TA_SDATA		UINT_C(0x20)    /* 硼ȥǡΰ */
#define TA_UNCACHE		UINT_C(0x40)    /* åԲ */
#define TA_IODEV		UINT_C(0x80)    /* եǥХΰ */

#define NO_STANDARD		UINT_C(0x0400)      /* ɸRAM꡼ */
#ifdef TOPPERS_TARGET_SUPPORT_ATT_MOD
#define TOPPERS_SUPPORT_ATT_MOD         /* ATT_MODݡȤƤ */
#endif /* TOPPERS_TARGET_SUPPORT_ATT_MOD */

/*
 * OSץꥱIDHRP2ݸɥᥤID
 */
#define TDOM_KERNEL		(-1)            /* ͥɥᥤ */
#define TDOM_NONE		(-2)            /* ̵°ݸɥᥤ°ʤ*/

#define TA_NULL			UINT_C(0)       /* ֥°ꤷʤ */

/*
 * OSץꥱطΥޥ
 */
#define TMAX_NTOSAPP		32          /* OSץꥱκ */

#endif /* TOPPERS_KERNEL_INT_H */
