/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2004-2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2014 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: scheduletable.c 345 2014-09-16 23:55:32Z fsi-dankei $
 */

/*
 *		塼ơ֥⥸塼
 */

#include "kernel_impl.h"
#include "check.h"
#include "scheduletable.h"

/*
 *  ȥ졼ޥΥǥե
 */
#ifndef LOG_STASCHTBLREL_ENTER
#define LOG_STASCHTBLREL_ENTER(schtblid, offset)
#endif /* LOG_STASCHTBLREL_ENTER */

#ifndef LOG_STASCHTBLREL_LEAVE
#define LOG_STASCHTBLREL_LEAVE(ercd)
#endif /* LOG_STASCHTBLREL_LEAVE */

#ifndef LOG_STASCHTBLABS_ENTER
#define LOG_STASCHTBLABS_ENTER(schtblid, start)
#endif /* LOG_STASCHTBLABS_ENTER */

#ifndef LOG_STASCHTBLABS_LEAVE
#define LOG_STASCHTBLABS_LEAVE(ercd)
#endif /* LOG_STASCHTBLABS_LEAVE */

#ifndef LOG_STPSCHTBL_ENTER
#define LOG_STPSCHTBL_ENTER(schtblid)
#endif /* LOG_STPSCHTBL_ENTER */

#ifndef LOG_STPSCHTBL_LEAVE
#define LOG_STPSCHTBL_LEAVE(ercd)
#endif /* LOG_STPSCHTBL_LEAVE */

#ifndef LOG_NXTSCHTBL_ENTER
#define LOG_NXTSCHTBL_ENTER(from, to)
#endif /* LOG_NXTSCHTBL_ENTER */

#ifndef LOG_NXTSCHTBL_LEAVE
#define LOG_NXTSCHTBL_LEAVE(ercd)
#endif /* LOG_NXTSCHTBL_LEAVE */

#ifndef LOG_GETSCHTBLST_ENTER
#define LOG_GETSCHTBLST_ENTER(schtblid)
#endif /* LOG_GETSCHTBLST_ENTER */

#ifndef LOG_GETSCHTBLST_LEAVE
#define LOG_GETSCHTBLST_LEAVE(ercd, p_status)
#endif /* LOG_GETSCHTBLST_LEAVE */

#ifndef LOG_SCHTBL_ENTER
#define LOG_SCHTBL_ENTER(p_schtblcb)
#endif /* LOG_SCHTBL_ENTER */

#ifndef LOG_SCHTBL_LEAVE
#define LOG_SCHTBL_LEAVE(p_schtblcb)
#endif /* LOG_SCHTBL_LEAVE */

/*
 *  塼ơ֥륪֥Ȥν
 */
#ifdef TOPPERS_schtbl_initialize

void
schtbl_initialize(void)
{
	ScheduleTableType	i;
	SCHTBLCB			*p_schtblcb;
	CNTCB				*p_cntcb;
	TickType			staval;
	CoreIdType			coreid = x_core_id();

	for (i = 0U; i < tnum_scheduletable; i++) {
		if ((schtblinib_table[i].p_cntcb->p_cntinib != NULL) &&
			(schtblinib_table[i].p_cntcb->p_cntinib->coreid == coreid)) {
			p_schtblcb = p_schtblcb_table[i];
			p_schtblcb->p_schtblinib = &(schtblinib_table[i]);

			/*
			 *  STOPPED֤ˤp_nextschtblcbp_prevschtblcb
			 *  RUNNINGNEXT֤ˤexpptindex
			 */
			p_schtblcb->p_nextschtblcb = NULL;
			p_schtblcb->p_prevschtblcb = NULL;
			(p_schtblcb->cntexpinfo).expirefunc = &schtbl_expire;

			if ((p_schtblcb->p_schtblinib->autosta & ((AppModeType) 1 << appmodeid)) != APPMODE_NONE) {
				if (is_implschtbl(i)) {
					p_schtblcb->status = SCHEDULETABLE_RUNNING_AND_SYNCHRONOUS;
				}
				else {
					p_schtblcb->status = SCHEDULETABLE_RUNNING;
				}
				p_schtblcb->expptindex = EXPPTINDEX_INITIAL;

				p_cntcb = p_schtblcb->p_schtblinib->p_cntcb;
				staval = p_schtblcb->p_schtblinib->staval;
				if (p_schtblcb->p_schtblinib->actatr == ABSOLUTE) {
					/*
					 *  л֤εư
					 *  λ֤0ξ硤μ0Υߥ󥰤Ȥʤ
					 *  get_abstick˹θѤߡ
					 */
					(p_schtblcb->cntexpinfo).expiretick = get_abstick(p_cntcb, staval);
				}
				else {
					/* л֤εư */
					(p_schtblcb->cntexpinfo).expiretick = get_reltick(p_cntcb, staval);
				}

				insert_cnt_expr_que(&(p_schtblcb->cntexpinfo), p_cntcb);
			}
			else {
				p_schtblcb->status = SCHEDULETABLE_STOPPED;

				queue_initialize(&(p_schtblcb->cntexpinfo.cntexpque));
			}
		}
	}
}

#endif /* TOPPERS_schtbl_initialize */

/*
 *  ꤷ塼ơ֥γ(л)
 */
#ifdef TOPPERS_StartScheduleTableRel

StatusType
StartScheduleTableRel(ScheduleTableType ScheduleTableID, TickType Offset)
{
	StatusType	ercd = E_OK;
	SCHTBLCB	*p_schtblcb;
	CNTCB		*p_cntcb;
	OSAPCB		*p_osapcb;
	CCB			*p_ccb;

	LOG_STASCHTBLREL_ENTER(ScheduleTableID, Offset);
	CHECK_DISABLEDINT();
	CHECK_CALLEVEL(CALLEVEL_STARTSCHEDULETABLEREL);
	CHECK_ID(ScheduleTableID < tnum_scheduletable);
	CHECK_ID(ScheduleTableID >= tnum_implscheduletable);

	p_schtblcb = get_schtblcb(ScheduleTableID);
	CHECK_CORE(p_schtblcb->p_schtblinib != NULL);
	CHECK_RIGHT(p_schtblcb->p_schtblinib->acsbtmp);
	p_cntcb = p_schtblcb->p_schtblinib->p_cntcb;

	CHECK_VALUE((Offset != 0U) &&
				((p_cntcb->p_cntinib->maxval - p_schtblcb->p_schtblinib->p_exppt->offset) >= Offset));

	p_osapcb = p_schtblcb->p_schtblinib->p_osapcb;
	p_ccb = get_p_ccb(p_cntcb->p_cntinib->coreid);
	x_nested_lock_os_int();
	acquire_cnt_lock(p_ccb);

	/* ư륹塼ơ֥°OSAPξ֤å */
	D_CHECK_ACCESS((p_osapcb->osap_stat == APPLICATION_ACCESSIBLE) ||
				   ((p_osapcb->osap_stat == APPLICATION_RESTARTING) &&
					(p_osapcb == get_my_p_ccb()->p_runosap)));
	S_D_CHECK_STATE(p_schtblcb->status == SCHEDULETABLE_STOPPED);

	p_schtblcb->status = SCHEDULETABLE_RUNNING;
	p_schtblcb->expptindex = EXPPTINDEX_INITIAL;
	p_schtblcb->cntexpinfo.expiretick = get_reltick(p_cntcb, Offset);

	insert_cnt_expr_que(&(p_schtblcb->cntexpinfo), p_cntcb);

  d_exit_no_errorhook:
	release_cnt_lock(p_ccb);
	x_nested_unlock_os_int();
  exit_no_errorhook:
	LOG_STASCHTBLREL_LEAVE(ercd);
	return(ercd);

#ifdef CFG_USE_ERRORHOOK
  d_exit_errorhook:
	release_cnt_lock(p_ccb);
	goto errorhook_start;

  exit_errorhook:
	x_nested_lock_os_int();
  errorhook_start:
#ifdef CFG_USE_PARAMETERACCESS
	get_my_p_ccb()->_errorhook_par1.schtblid = ScheduleTableID;
	get_my_p_ccb()->_errorhook_par2.offset = Offset;
#endif /* CFG_USE_PARAMETERACCESS */
	call_errorhook(ercd, OSServiceId_StartScheduleTableRel);
	x_nested_unlock_os_int();
	goto exit_no_errorhook;
#endif /* CFG_USE_ERRORHOOK */
}

#endif /* TOPPERS_StartScheduleTableRel */

/*
 *  ꤷ塼ơ֥γ(л)
 */
#ifdef TOPPERS_StartScheduleTableAbs

StatusType
StartScheduleTableAbs(ScheduleTableType ScheduleTableID, TickType Start)
{
	StatusType	ercd = E_OK;
	SCHTBLCB	*p_schtblcb;
	CNTCB		*p_cntcb;
	OSAPCB		*p_osapcb;
	CCB			*p_ccb;

	LOG_STASCHTBLABS_ENTER(ScheduleTableID, Start);
	CHECK_DISABLEDINT();
	CHECK_CALLEVEL(CALLEVEL_STARTSCHEDULETABLEABS);
	CHECK_ID(ScheduleTableID < tnum_scheduletable);

	p_schtblcb = get_schtblcb(ScheduleTableID);
	CHECK_CORE(p_schtblcb->p_schtblinib != NULL);
	CHECK_RIGHT(p_schtblcb->p_schtblinib->acsbtmp);
	p_cntcb = p_schtblcb->p_schtblinib->p_cntcb;

	CHECK_VALUE(p_cntcb->p_cntinib->maxval >= Start);
	p_osapcb = p_schtblcb->p_schtblinib->p_osapcb;
	p_ccb = get_p_ccb(p_cntcb->p_cntinib->coreid);

	x_nested_lock_os_int();
	acquire_cnt_lock(p_ccb);

	/* ư륹塼ơ֥°OSAPξ֤å */
	D_CHECK_ACCESS((p_osapcb->osap_stat == APPLICATION_ACCESSIBLE) ||
				   ((p_osapcb->osap_stat == APPLICATION_RESTARTING) &&
					(p_osapcb == get_my_p_ccb()->p_runosap)));
	S_D_CHECK_STATE(p_schtblcb->status == SCHEDULETABLE_STOPPED);

	/* Ʊξ硤Ʊư֤ư */
	if (is_implschtbl(ScheduleTableID)) {
		p_schtblcb->status = SCHEDULETABLE_RUNNING_AND_SYNCHRONOUS;
	}
	else {
		p_schtblcb->status = SCHEDULETABLE_RUNNING;
	}
	p_schtblcb->expptindex = EXPPTINDEX_INITIAL;
	p_schtblcb->cntexpinfo.expiretick = get_abstick(p_cntcb, Start);

	insert_cnt_expr_que(&(p_schtblcb->cntexpinfo), p_cntcb);

  d_exit_no_errorhook:
	release_cnt_lock(p_ccb);
	x_nested_unlock_os_int();
  exit_no_errorhook:
	LOG_STASCHTBLABS_LEAVE(ercd);
	return(ercd);

#ifdef CFG_USE_ERRORHOOK
  d_exit_errorhook:
	release_cnt_lock(p_ccb);
	goto errorhook_start;

  exit_errorhook:
	x_nested_lock_os_int();
  errorhook_start:
#ifdef CFG_USE_PARAMETERACCESS
	get_my_p_ccb()->_errorhook_par1.schtblid = ScheduleTableID;
	get_my_p_ccb()->_errorhook_par2.start = Start;
#endif /* CFG_USE_PARAMETERACCESS */
	call_errorhook(ercd, OSServiceId_StartScheduleTableAbs);
	x_nested_unlock_os_int();
	goto exit_no_errorhook;
#endif /* CFG_USE_ERRORHOOK */
}

#endif /* TOPPERS_StartScheduleTableAbs */

/*
 *  ꤷ塼ơ֥
 */
#ifdef TOPPERS_StopScheduleTable

StatusType
StopScheduleTable(ScheduleTableType ScheduleTableID)
{
	StatusType	ercd = E_OK;
	SCHTBLCB	*p_schtblcb, *p_nextcb;
	CNTCB		*p_cntcb;
	OSAPCB		*p_osapcb;
	CCB			*p_ccb;

	LOG_STPSCHTBL_ENTER(ScheduleTableID);
	CHECK_DISABLEDINT();
	CHECK_CALLEVEL(CALLEVEL_STOPSCHEDULETABLE);
	CHECK_ID(ScheduleTableID < tnum_scheduletable);

	p_schtblcb = get_schtblcb(ScheduleTableID);
	CHECK_CORE(p_schtblcb->p_schtblinib != NULL);
	CHECK_RIGHT(p_schtblcb->p_schtblinib->acsbtmp);

	p_cntcb = p_schtblcb->p_schtblinib->p_cntcb;
	p_osapcb = p_schtblcb->p_schtblinib->p_osapcb;
	p_ccb = get_p_ccb(p_cntcb->p_cntinib->coreid);

	x_nested_lock_os_int();
	acquire_cnt_lock(p_ccb);

	/* ߤ륹塼°OSAPξ֤å */
	D_CHECK_ACCESS((p_osapcb->osap_stat == APPLICATION_ACCESSIBLE) ||
				   ((p_osapcb->osap_stat == APPLICATION_RESTARTING) &&
					(p_osapcb == get_my_p_ccb()->p_runosap)));
	S_D_CHECK_NOFUNC(p_schtblcb->status != SCHEDULETABLE_STOPPED);

	/*
	 *  ꤵ줿塼ơ֥뤬SCHEDULETABLE_NEXTξ,
	 *  ʬNextˤ塼ơ֥뤫顤ʬ򳰤
	 */
	if (p_schtblcb->status == SCHEDULETABLE_NEXT) {
		p_schtblcb->p_prevschtblcb->p_nextschtblcb = NULL;
		p_schtblcb->p_prevschtblcb = NULL;
	}
	else {
		/*
		 *  Next塼ơ֥뤬¸ߤ,
		 *  Next塼ơ֥ͽ򥭥󥻥뤹
		 */
		p_nextcb = p_schtblcb->p_nextschtblcb;
		if (p_nextcb != NULL) {
			p_nextcb->status = SCHEDULETABLE_STOPPED;
			p_nextcb->p_prevschtblcb = NULL;
			p_schtblcb->p_nextschtblcb = NULL;
		}

		/* λ塼Ͽλ */
		delete_cnt_expr_que(&(p_schtblcb->cntexpinfo), p_cntcb);
	}

	p_schtblcb->status = SCHEDULETABLE_STOPPED;

  d_exit_no_errorhook:
	release_cnt_lock(p_ccb);
	x_nested_unlock_os_int();
  exit_no_errorhook:
	LOG_STPSCHTBL_LEAVE(ercd);
	return(ercd);

#ifdef CFG_USE_ERRORHOOK
  d_exit_errorhook:
	release_cnt_lock(p_ccb);
	goto errorhook_start;

  exit_errorhook:
	x_nested_lock_os_int();
  errorhook_start:
#ifdef CFG_USE_PARAMETERACCESS
	get_my_p_ccb()->_errorhook_par1.schtblid = ScheduleTableID;
#endif /* CFG_USE_PARAMETERACCESS */
	call_errorhook(ercd, OSServiceId_StopScheduleTable);
	x_nested_unlock_os_int();
	goto exit_no_errorhook;
#endif /* CFG_USE_ERRORHOOK */
}
#endif /* TOPPERS_StopScheduleTable */

/*
 *  塼ơ֥ؤ
 */
#ifdef TOPPERS_NextScheduleTable

StatusType
NextScheduleTable(ScheduleTableType ScheduleTableID_From,
				  ScheduleTableType ScheduleTableID_To)
{
	StatusType	ercd = E_OK;
	SCHTBLCB	*p_curcb, *p_nextcb;
	OSAPCB		*p_osapcb;
	CCB			*p_ccb;

	LOG_NXTSCHTBL_ENTER(ScheduleTableID_From, ScheduleTableID_To);
	CHECK_DISABLEDINT();
	CHECK_CALLEVEL(CALLEVEL_NEXTSCHEDULETABLE);
	CHECK_ID(ScheduleTableID_From < tnum_scheduletable);
	CHECK_ID(ScheduleTableID_To < tnum_scheduletable);
	CHECK_ID((ScheduleTableID_From < tnum_implscheduletable) ==
			 (ScheduleTableID_To < tnum_implscheduletable));

	p_curcb = get_schtblcb(ScheduleTableID_From);
	p_nextcb = get_schtblcb(ScheduleTableID_To);

	CHECK_CORE(p_curcb->p_schtblinib != NULL);
	CHECK_CORE(p_nextcb->p_schtblinib != NULL);
	CHECK_RIGHT(p_curcb->p_schtblinib->acsbtmp);
	CHECK_RIGHT(p_nextcb->p_schtblinib->acsbtmp);
	CHECK_ID(p_curcb->p_schtblinib->p_cntcb == p_nextcb->p_schtblinib->p_cntcb);

	p_ccb = get_p_ccb(p_curcb->p_schtblinib->p_cntcb->p_cntinib->coreid);
	x_nested_lock_os_int();
	acquire_cnt_lock(p_ccb);

	p_osapcb = p_curcb->p_schtblinib->p_osapcb;
	/* ư륹塼ơ֥°OSAPξ֤å */
	D_CHECK_ACCESS((p_osapcb->osap_stat == APPLICATION_ACCESSIBLE) ||
				   ((p_osapcb->osap_stat == APPLICATION_RESTARTING) &&
					(p_osapcb == get_my_p_ccb()->p_runosap)));

	p_osapcb = p_nextcb->p_schtblinib->p_osapcb;
	/* ư륹塼ơ֥°OSAPξ֤å */
	D_CHECK_ACCESS((p_osapcb->osap_stat == APPLICATION_ACCESSIBLE) ||
				   ((p_osapcb->osap_stat == APPLICATION_RESTARTING) &&
					(p_osapcb == get_my_p_ccb()->p_runosap)));

	/* ScheduleTableID_Fromξ֥å */
	S_D_CHECK_NOFUNC((p_curcb->status & (SCHEDULETABLE_STOPPED | SCHEDULETABLE_NEXT)) == 0U);

	/* ScheduleTableID_Toξ֥å */
	S_D_CHECK_STATE(p_nextcb->status == SCHEDULETABLE_STOPPED);

	/*
	 *  CurrentФƴNext¸ߤ,
	 *  ޤǤNextФƥ󥻥뤹
	 */
	if (p_curcb->p_nextschtblcb != NULL) {
		p_curcb->p_nextschtblcb->status = SCHEDULETABLE_STOPPED;
		p_curcb->p_nextschtblcb->p_prevschtblcb = NULL;
	}

	p_curcb->p_nextschtblcb = p_nextcb;
	p_nextcb->status = SCHEDULETABLE_NEXT;
	p_nextcb->p_prevschtblcb = p_curcb;

  d_exit_no_errorhook:
	release_cnt_lock(p_ccb);
	x_nested_unlock_os_int();
  exit_no_errorhook:
	LOG_NXTSCHTBL_LEAVE(ercd);
	return(ercd);

#ifdef CFG_USE_ERRORHOOK
  d_exit_errorhook:
	release_cnt_lock(p_ccb);
	goto errorhook_start;

  exit_errorhook:
	x_nested_lock_os_int();
  errorhook_start:
#ifdef CFG_USE_PARAMETERACCESS
	get_my_p_ccb()->_errorhook_par1.schtblid_from = ScheduleTableID_From;
	get_my_p_ccb()->_errorhook_par2.schtblid_to = ScheduleTableID_To;
#endif /* CFG_USE_PARAMETERACCESS */
	call_errorhook(ercd, OSServiceId_NextScheduleTable);
	x_nested_unlock_os_int();
	goto exit_no_errorhook;
#endif /* CFG_USE_ERRORHOOK */
}

#endif /* TOPPERS_NextScheduleTable */

/*
 *  塼ơ֥֤μ
 */
#ifdef TOPPERS_GetScheduleTableStatus

StatusType
GetScheduleTableStatus(ScheduleTableType ScheduleTableID,
					   ScheduleTableStatusRefType ScheduleStatus)
{
	StatusType	ercd = E_OK;
	SCHTBLCB	*p_schtblcb;
	OSAPCB		*p_osapcb;

	LOG_GETSCHTBLST_ENTER(ScheduleTableID);
	CHECK_DISABLEDINT();
	CHECK_CALLEVEL(CALLEVEL_GETSCHEDULETABLESTATUS);
	CHECK_ID(ScheduleTableID < tnum_scheduletable);
	CHECK_PARAM_POINTER(ScheduleStatus);
	CHECK_MEM_WRITE(ScheduleStatus, ScheduleTableStatusType);

	p_schtblcb = get_schtblcb(ScheduleTableID);
	CHECK_CORE(p_schtblcb->p_schtblinib != NULL);
	CHECK_RIGHT(p_schtblcb->p_schtblinib->acsbtmp);

	/* 塼ơ֥°OSAPξ֤å */
	p_osapcb = p_schtblcb->p_schtblinib->p_osapcb;
	CHECK_ACCESS((p_osapcb->osap_stat == APPLICATION_ACCESSIBLE) ||
				 ((p_osapcb->osap_stat == APPLICATION_RESTARTING) &&
				  (p_osapcb == get_my_p_ccb()->p_runosap)));

	*ScheduleStatus = p_schtblcb->status;

  exit_no_errorhook:
	LOG_GETSCHTBLST_LEAVE(ercd, ScheduleStatus);
	return(ercd);

#ifdef CFG_USE_ERRORHOOK
  exit_errorhook:
	x_nested_lock_os_int();
#ifdef CFG_USE_PARAMETERACCESS
	get_my_p_ccb()->_errorhook_par1.schtblid = ScheduleTableID;
	get_my_p_ccb()->_errorhook_par2.p_schtblstate = ScheduleStatus;
#endif /* CFG_USE_PARAMETERACCESS */
	call_errorhook(ercd, OSServiceId_GetScheduleTableStatus);
	x_nested_unlock_os_int();
	goto exit_no_errorhook;
#endif /* CFG_USE_ERRORHOOK */
}

#endif /* TOPPERS_GetScheduleTableStatus */

/*
 *  塼λؿ
 */
#ifdef TOPPERS_schtbl_expire

void
schtbl_expire(CNTEXPINFO *p_cntexpinfo, const CNTCB *p_cntcb)
{
	SCHTBLEXPINFO schtblexpinfo;

	schtblexpinfo.p_schtblcb = (SCHTBLCB *) p_cntexpinfo;

	schtbl_expiry_process(&schtblexpinfo, p_cntcb);

	if (schtblexpinfo.p_schtblcb != NULL) {
		insert_cnt_expr_que(&(schtblexpinfo.p_schtblcb->cntexpinfo), p_cntcb);
	}
}

#endif /* TOPPERS_schtbl_expire */

/*
 *  λؿƥߥ󥰽μ¹
 */
#ifdef TOPPERS_schtbl_expiry_process

void
schtbl_expiry_process(SCHTBLEXPINFO *p_schtblexpinfo, const CNTCB *p_cntcb)
{
	boolean		loopcont = FALSE;
	SCHTBLCB	*p_schtblcb;

	/*
	 *  ꤷλϡλǽΤǡ
	 *  ֤ˤäƥ롼׽
	 */
	do {
		p_schtblcb = p_schtblexpinfo->p_schtblcb;

		if (p_schtblcb->expptindex < p_schtblcb->p_schtblinib->tnum_exppt) {
			/* λ */
			loopcont = schtbl_exppoint_process(p_schtblcb, p_cntcb);
		}
		else if (p_schtblcb->expptindex == p_schtblcb->p_schtblinib->tnum_exppt) {
			/* κǸ */
			loopcont = schtbl_tail(p_schtblcb, p_schtblexpinfo, p_cntcb);
		}
		else {
			/*
			 *  γϻ
			 *  p_schtblcb->expptindex == EXPPTINDEX_INITIALʤ
			 */
			loopcont = schtbl_head(p_schtblcb, p_cntcb);
		}
	} while (loopcont != FALSE);
}

#endif /* TOPPERS_schtbl_expiry_process */

/*
 *  塼ơ֥γϽ
 */
#ifdef TOPPERS_schtbl_head

boolean
schtbl_head(SCHTBLCB *p_schtblcb, const CNTCB *p_cntcb)
{
	boolean				loopcont;
	const SCHTBLEXPPTCB	*p_exppoint;

	p_exppoint = &(p_schtblcb->p_schtblinib->p_exppt[EXPPTINDEX_TOP]);

	if (p_exppoint->offset == 0U) {
		/* եå0ξ硤λ1ܤλԤ */
		loopcont = TRUE;
	}
	else {
		loopcont = FALSE;
		/* ˵ư٤֤ */
		p_schtblcb->cntexpinfo.expiretick = add_tick(p_schtblcb->cntexpinfo.expiretick,
													 p_exppoint->offset, p_cntcb->p_cntinib->maxval2);
	}

	p_schtblcb->expptindex = EXPPTINDEX_TOP;

	return(loopcont);
}

#endif /* TOPPERS_schtbl_head */

/*
 *  塼ơ֥γλ
 */
#ifdef TOPPERS_schtbl_exppoint_process

boolean
schtbl_exppoint_process(SCHTBLCB *p_schtblcb, const CNTCB *p_cntcb)
{
	boolean				loopcont = FALSE;
	const SCHTBLEXPPTCB	*p_exppoint;
	TickType			currtime;
	OSAPCB				*p_runosap_saved;
	CCB					*p_ccb = get_my_p_ccb();

	p_exppoint = &(p_schtblcb->p_schtblinib->p_exppt[p_schtblcb->expptindex]);

	/* λμ¹ */
	release_cnt_lock(p_ccb);
	LOG_SCHTBL_ENTER(p_schtblcb);
	p_runosap_saved = p_ccb->p_runosap;
	p_ccb->p_runosap = p_schtblcb->p_schtblinib->p_osapcb;

	(p_exppoint->expptfnt)();

	p_ccb->p_runosap = p_runosap_saved;

	LOG_SCHTBL_LEAVE(p_schtblcb);
	acquire_cnt_lock(p_ccb);

	/* ߻֤ */
	currtime = p_exppoint->offset;
	/* λ */
	p_schtblcb->expptindex++;
	p_exppoint++;

	if (p_schtblcb->expptindex == p_schtblcb->p_schtblinib->tnum_exppt) {
		/* ߤκǸλξ */
		if (p_schtblcb->p_schtblinib->length == currtime) {
			/*
			 *  ñȯ塼ơ֥ǽٱͤ0ξ硤Next¸ߤ뤫⤷ʤᡤ
			 *  塼ơ֥κǸ奿ߥ󥰽򤹤
			 */
			loopcont = TRUE;
		}
		else {
			/* ǽٱΤᡤλ֤ */
			p_schtblcb->cntexpinfo.expiretick = add_tick(p_schtblcb->cntexpinfo.expiretick,
														 (p_schtblcb->p_schtblinib->length - currtime), p_cntcb->p_cntinib->maxval2);
		}
	}
	else {
		/* λλ֤ */
		p_schtblcb->cntexpinfo.expiretick = add_tick(p_schtblcb->cntexpinfo.expiretick,
													 (p_exppoint->offset - currtime), p_cntcb->p_cntinib->maxval2);
	}

	return(loopcont);
}

#endif /* TOPPERS_schtbl_exppoint_process */

/*
 *  塼ơ֥νü
 */
#ifdef TOPPERS_schtbl_tail

boolean
schtbl_tail(SCHTBLCB *p_schtblcb, SCHTBLEXPINFO *p_schtblexpinfo, const CNTCB *p_cntcb)
{
	boolean				loopcont = FALSE;
	SCHTBLCB			*p_nextcb;
	const SCHTBLEXPPTCB	*p_exppoint;

	/* κǸˤNext¸ߤ뤫å */
	if (p_schtblcb->p_nextschtblcb != NULL) {
		p_nextcb = p_schtblcb->p_nextschtblcb;

		/*
		 *  塼ơ֥ڤؤ
		 *
		 *  ƱƱΤؤθ֤ΰѤɬ
		 *  NextScheduleTableƱˡåƤΤǡ
		 *  Ʊˡ礬ʤ
		 */
		p_nextcb->status = p_schtblcb->status;
		p_nextcb->expptindex = EXPPTINDEX_INITIAL;

		/* NextλϡPrevλȤʤ */
		p_nextcb->cntexpinfo.expiretick = p_schtblcb->cntexpinfo.expiretick;
		p_nextcb->p_prevschtblcb = NULL;

		/* ޤǼ¹Ծ֤Υ塼ơ֥Фƽλ */
		p_schtblcb->status = SCHEDULETABLE_STOPPED;
		p_schtblcb->p_nextschtblcb = NULL;

		/*
		 *  ή¦Nextνλ򥫥λ塼ɲä
		 *  Ѥ
		 */
		p_schtblexpinfo->p_schtblcb = p_nextcb;

		loopcont = TRUE;
	}
	else {
		/* ̵ͭå */
		if (p_schtblcb->p_schtblinib->repeat != FALSE) {

			p_schtblcb->expptindex = EXPPTINDEX_TOP;
			p_exppoint = &(p_schtblcb->p_schtblinib->p_exppt[EXPPTINDEX_TOP]);

			if (p_exppoint->offset == 0U) {
				/* եå0ξ硤λ1ܤλԤ */
				loopcont = TRUE;
			}
			else {
				/* ǽٱΤᡤλ֤ */
				p_schtblcb->cntexpinfo.expiretick = add_tick(p_schtblcb->cntexpinfo.expiretick,
															 p_exppoint->offset, p_cntcb->p_cntinib->maxval2);
			}
		}
		else {
			/* ưʤΤǡλ */
			p_schtblcb->status = SCHEDULETABLE_STOPPED;
			p_schtblexpinfo->p_schtblcb = NULL;
			p_schtblcb->p_prevschtblcb = NULL;
			p_schtblcb->p_nextschtblcb = NULL;
		}
	}

	return(loopcont);
}

#endif /* TOPPERS_schtbl_tail */

/*
 *  OSAP°륹塼ơ֥ζλ
 */
#ifdef TOPPERS_force_term_osap_schtbl

void
force_term_osap_schtbl(OSAPCB *p_osapcb)
{
	ScheduleTableType	i;
	SCHTBLCB			*p_schtblcb;
	SCHTBLCB			*p_nextcb;

	for (i = 0U; i < tnum_scheduletable; i++) {
		if (schtblinib_table[i].p_osapcb == p_osapcb) {
			p_schtblcb = p_schtblcb_table[i];
			/*
			 *  ꤵ줿塼ơ֥뤬SCHEDULETABLE_NEXTξ,
			 *  ʬNextˤ塼ơ֥뤫顤ʬ򳰤
			 */
			if (p_schtblcb->status == SCHEDULETABLE_NEXT) {
				p_schtblcb->p_prevschtblcb->p_nextschtblcb = NULL;
				p_schtblcb->p_prevschtblcb = NULL;
				p_schtblcb->expptindex = EXPPTINDEX_INITIAL;
				p_schtblcb->status = SCHEDULETABLE_STOPPED;
			}
			else if ((p_schtblcb->status == SCHEDULETABLE_RUNNING) ||
					 (p_schtblcb->status == SCHEDULETABLE_RUNNING_AND_SYNCHRONOUS)) {
				/*
				 *  Next塼ơ֥뤬¸ߤ,
				 *  Next塼ơ֥ͽ򥭥󥻥뤹
				 */
				p_nextcb = p_schtblcb->p_nextschtblcb;
				if (p_nextcb != NULL) {
					p_nextcb->status = SCHEDULETABLE_STOPPED;
					p_nextcb->p_prevschtblcb = NULL;
					p_schtblcb->p_nextschtblcb = NULL;
				}

				/* λ塼Ͽλ */
				delete_cnt_expr_que(&(p_schtblcb->cntexpinfo),
									p_schtblcb->p_schtblinib->p_cntcb);
				p_schtblcb->status = SCHEDULETABLE_STOPPED;
			}
			else {
				/* »ܤ٤Ȥʤ */
			}
		}
	}
}

#endif /* TOPPERS_force_term_osap_schtbl */
