/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2014 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by Spansion LLC, USA
 *  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: spinlock.c 345 2014-09-16 23:55:32Z fsi-dankei $
 */

/*
 * ԥåǽ⥸塼
 */

#include "kernel_impl.h"
#include "check.h"
#include "mc.h"
#include "task.h"
#include "interrupt.h"
#include "spinlock.h"

/*
 *  ȥ졼ޥΥǥե
 */

#ifndef LOG_WSUSALL_ENTER
#define LOG_WSUSALL_ENTER()
#endif /* LOG_WSUSALL_ENTER */

#ifndef LOG_WSUSALL_LEAVE
#define LOG_WSUSALL_LEAVE()
#endif /* LOG_WSUSALL_LEAVE */

#ifndef LOG_WRSMALL_ENTER
#define LOG_WRSMALL_ENTER()
#endif /* LOG_WRSMALL_ENTER */

#ifndef LOG_WRSMALL_LEAVE
#define LOG_WRSMALL_LEAVE()
#endif /* LOG_WRSMALL_LEAVE */

#ifndef LOG_WSUSOSI_ENTER
#define LOG_WSUSOSI_ENTER()
#endif /* LOG_WSUSOSI_ENTER */

#ifndef LOG_WSUSOSI_LEAVE
#define LOG_WSUSOSI_LEAVE()
#endif /* LOG_WSUSOSI_LEAVE */

#ifndef LOG_WRSMOSI_ENTER
#define LOG_WRSMOSI_ENTER()
#endif /* LOG_WRSMOSI_ENTER */

#ifndef LOG_WRSMOSI_LEAVE
#define LOG_WRSMOSI_LEAVE()
#endif /* LOG_WRSMOSI_LEAVE */

#ifndef LOG_GETSPN_ENTER
#define LOG_GETSPN_ENTER(spinlockid)
#endif /* LOG_GETSPN_ENTER */

#ifndef LOG_GETSPN_LEAVE
#define LOG_GETSPN_LEAVE(ercd)
#endif /* LOG_GETSPN_LEAVE */

#ifndef LOG_RELSPN_ENTER
#define LOG_RELSPN_ENTER(spinlockid)
#endif /* LOG_RELSPN_ENTER */

#ifndef LOG_RELSPN_LEAVE
#define LOG_RELSPN_LEAVE(ercd)
#endif /* LOG_RELSPN_LEAVE */

#ifndef LOG_TRYSPN_ENTER
#define LOG_TRYSPN_ENTER(spinlockid)
#endif /* LOG_TRYSPN_ENTER */

#ifndef LOG_TRYSPN_LEAVE
#define LOG_TRYSPN_LEAVE(ercd, p_success)
#endif /* LOG_TRYSPN_LEAVE */

#ifdef TOPPERS_spinlock_initialize

void
spinlock_initialize(void)
{
	SpinlockIdType	i;
	SPNCB			*p_spncb;
	const SPNINIB	*p_spninib;

	if (x_sense_mcore() != FALSE) {
		for (i = 1U; i <= tnum_spinlock; i++) {
			p_spninib = get_spninib(i);
			p_spncb = get_spncb(i);
			p_spncb->p_spninib = p_spninib;
			p_spncb->p_holdcb = NULL;
			p_spncb->p_ccb = NULL;
			p_spncb->p_prevspncb = NULL;
		}
	}
}

#endif /* TOPPERS_spinlock_initialize */

/*
 *  ͥȥå
 */
LOCAL_INLINE boolean
check_nest_spn_order(const SPNINIB *p_get_spninib, const SPNCB *p_lastspncb)
{
	boolean			nest_flag;
	const SPNINIB	*p_spninib;

	if (p_lastspncb != NULL) {
		/* ͥȤƤ */
		nest_flag = FALSE;
		p_spninib = p_lastspncb->p_spninib;
		while (p_spninib->p_nextspn != NULL) {
			p_spninib = p_spninib->p_nextspn;
			if (p_spninib == p_get_spninib) {
				/* ե졼󤷤̤ */
				nest_flag = TRUE;
				break;
			}
		}
	}
	else {
		/* ͥȤƤʤ */
		nest_flag = TRUE;
	}

	return(nest_flag);
}

/*
 *  ԥååԥ󥰤߶ػ
 */
#ifdef TOPPERS_wrap_sus_all_int

StatusType
wrap_sus_all_int(void)
{
	StatusType	ercd = E_OK;
	CCB			*p_ccb = get_my_p_ccb();

	LOG_WSUSALL_ENTER();

	/* ͥȲξĶ */
	S_CHECK_LIMIT(p_ccb->sus_all_cnt != UINT8_INVALID);

	if (p_ccb->sus_all_cnt == 0U) {
		x_lock_all_int();
		ENTER_CALLEVEL(TSYS_SUSALLINT);
	}

	p_ccb->sus_all_cnt++;
	p_ccb->sus_all_cnt_ctx++;
	p_ccb->wrap_sus_all_cnt++;

  error_exit:
	LOG_WSUSALL_LEAVE();
	return(ercd);
}

#endif /* TOPPERS_wrap_sus_all_int */

/*
 *  ԥååԥ󥰤߶ػ߲
 */
#ifdef TOPPERS_wrap_res_all_int

void
wrap_res_all_int(void)
{
	CCB	*p_ccb = get_my_p_ccb();

	LOG_WRSMALL_ENTER();

	/*
	 *  ؿʤΤǡǤϥͥȲΥåԤʤ
	 */

	p_ccb->sus_all_cnt--;
	p_ccb->sus_all_cnt_ctx--;
	p_ccb->wrap_sus_all_cnt--;

	if (p_ccb->sus_all_cnt == 0U) {
		LEAVE_CALLEVEL(TSYS_SUSALLINT);
		x_unlock_all_int();
	}

	LOG_WRSMALL_LEAVE();
}

#endif /* TOPPERS_wrap_res_all_int */

/*
 *  ԥååԥ󥰤OS߶ػ
 */
#ifdef TOPPERS_wrap_sus_os_int

StatusType
wrap_sus_os_int(void)
{
	StatusType	ercd = E_OK;
	CCB			*p_ccb = get_my_p_ccb();

	LOG_WSUSOSI_ENTER();

	/* ͥȲξĶ */
	S_CHECK_LIMIT(p_ccb->sus_os_cnt != UINT8_INVALID);

	if (p_ccb->sus_os_cnt == 0U) {
		x_suspend_lock_os_int();
		ENTER_CALLEVEL(TSYS_SUSOSINT);
	}

	p_ccb->sus_os_cnt++;
	p_ccb->sus_os_cnt_ctx++;
	p_ccb->wrap_sus_os_cnt++;

  error_exit:
	LOG_WSUSOSI_LEAVE();
	return(ercd);
}

#endif /* TOPPERS_wrap_sus_os_int */

/*
 *  ԥååԥ󥰤OS߶ػ߲
 */
#ifdef TOPPERS_wrap_res_os_int

void
wrap_res_os_int(void)
{
	CCB	*p_ccb = get_my_p_ccb();

	LOG_WRSMOSI_ENTER();

	/*
	 *  ؿʤΤǡǤϥͥȲΥåԤʤ
	 */

	p_ccb->sus_os_cnt--;
	p_ccb->sus_os_cnt_ctx--;
	p_ccb->wrap_sus_os_cnt--;

	if (p_ccb->sus_os_cnt == 0U) {
		LEAVE_CALLEVEL(TSYS_SUSOSINT);
		x_resume_unlock_os_int();
	}

	LOG_WRSMOSI_LEAVE();
}

#endif /* TOPPERS_wrap_res_os_int */

/*
 *  ԥåμ
 */
#ifdef TOPPERS_GetSpinlock

StatusType
GetSpinlock(SpinlockIdType SpinlockId)
{
	StatusType		ercd = E_OK;
	SPNCB			*p_spncb;
	SPNCB			**pp_lastspncb;
	const SPNINIB	*p_spninib;
	CCB				*p_ccb = get_my_p_ccb();

	LOG_GETSPN_ENTER(SpinlockId);
	S_CHECK_DISALLINT();
	CHECK_CALLEVEL(CALLEVEL_GETSPINLOCK);
	CHECK_ID((SpinlockId != INVALID_SPINLOCK) && (SpinlockId <= tnum_spinlock));
	p_spncb = get_spncb(SpinlockId);
	CHECK_RIGHT(p_spncb->p_spninib->acsbtmp);
	CHECK_INTER_DEADLOCK(p_spncb->p_ccb != p_ccb);
	if ((p_ccb->callevel_stat & TCL_PROTECT) != 0U) {
		pp_lastspncb = (&(p_ccb->p_protectspncb));
	}
	else if (p_ccb->p_runisr != NULL) {
		pp_lastspncb = (&(p_ccb->p_runisr->p_lastspncb));
	}
	else {
		pp_lastspncb = (&(p_ccb->p_runtsk->p_lastspncb));
	}
	p_spninib = get_spninib(SpinlockId);
	CHECK_NEST_DEADLOCK(check_nest_spn_order(p_spninib, *pp_lastspncb) != FALSE);

	while (1) {
		/* ԥåå */
		x_nested_lock_os_int();
		acquire_spn_lock(GET_SPNLOCK());
		if (p_spncb->p_holdcb == NULL) {
			/* ԥåǤ */
			break;
		}
		release_spn_lock(GET_SPNLOCK());
		x_nested_unlock_os_int();
		/* ǳ߽¹Ԥ */
	}

	/*
	 * ԥå˳߶ػߤԤϡǳ߶ػߤ
	 * Ԥ߶ػߤͥȲξ¤ãˡå
	 * ʤ褦ˤ뤿
	 */
	if (p_spninib->susint != NULL) {
		ercd = p_spninib->susint();
		if (ercd != E_OK) {
			release_spn_lock(GET_SPNLOCK());
			goto d_error_exit;
		}
	}

	p_spncb->p_ccb = p_ccb;
	if ((p_ccb->callevel_stat & TCL_PROTECT) != 0U) {
		p_spncb->p_holdcb = (void *) &(p_ccb->p_protectspncb);
	}
	else if (p_ccb->p_runisr != NULL) {
		p_spncb->p_holdcb = (void *) (p_ccb->p_runisr);
	}
	else {
		p_spncb->p_holdcb = (void *) (p_ccb->p_runtsk);
	}
	p_spncb->p_prevspncb = *pp_lastspncb;
	*pp_lastspncb = p_spncb;

	/* ԥåå */
	release_spn_lock(GET_SPNLOCK());

  d_exit_no_errorhook:
	x_nested_unlock_os_int();
  exit_no_errorhook:
	LOG_GETSPN_LEAVE(ercd);
	return(ercd);

#ifdef CFG_USE_ERRORHOOK
  exit_errorhook:
	x_nested_lock_os_int();
  d_exit_errorhook:
#ifdef CFG_USE_PARAMETERACCESS
	p_ccb->_errorhook_par1.spnid = SpinlockId;
#endif /* CFG_USE_PARAMETERACCESS */
	call_errorhook(ercd, OSServiceId_GetSpinlock);
	goto d_exit_no_errorhook;
#endif /* CFG_USE_ERRORHOOK */
}

#endif /* TOPPERS_GetSpinlock */

/*
 *  ԥåβ
 */
#ifdef TOPPERS_ReleaseSpinlock

StatusType
ReleaseSpinlock(SpinlockIdType SpinlockId)
{
	StatusType		ercd = E_OK;
	SPNCB			*p_spncb;
	SPNCB			**pp_lastspncb;
	const SPNINIB	*p_spninib;
	CCB				*p_ccb = get_my_p_ccb();
	void			*p_run;

	LOG_RELSPN_ENTER(SpinlockId);
	S_CHECK_DISALLINT();
	CHECK_CALLEVEL(CALLEVEL_RELEASESPINLOCK);
	CHECK_ID((SpinlockId != INVALID_SPINLOCK) && (SpinlockId <= tnum_spinlock));
	p_spncb = get_spncb(SpinlockId);
	CHECK_RIGHT(p_spncb->p_spninib->acsbtmp);
	if ((p_ccb->callevel_stat & TCL_PROTECT) != 0U) {
		p_run = &(p_ccb->p_protectspncb);
		pp_lastspncb = &(p_ccb->p_protectspncb);
	}
	else if (p_ccb->p_runisr != NULL) {
		p_run = p_ccb->p_runisr;
		pp_lastspncb = &(p_ccb->p_runisr->p_lastspncb);
	}
	else {
		p_run = p_ccb->p_runtsk;
		pp_lastspncb = &(p_ccb->p_runtsk->p_lastspncb);
	}
	CHECK_STATE(p_run == p_spncb->p_holdcb);
	CHECK_NOFUNC(*pp_lastspncb == p_spncb);

	p_spninib = get_spninib(SpinlockId);

	/* ԥåå */
	x_nested_lock_os_int();
	acquire_spn_lock(GET_SPNLOCK());

	/* ԥå */
	p_spncb->p_ccb = NULL;
	p_spncb->p_holdcb = NULL;
	*pp_lastspncb = p_spncb->p_prevspncb;

	/* ԥåå */
	release_spn_lock(GET_SPNLOCK());
	x_nested_unlock_os_int();

	/*
	 * ԥå˳߶ػߤԤϡǳ߶ػߤ
	 * 
	 */
	if (p_spninib->resint != NULL) {
		/*
		 * ߶ػߤβǥ顼ȯ뤳ȤϤʤ
		 */
		p_spninib->resint();
	}

  exit_no_errorhook:
	LOG_RELSPN_LEAVE(ercd);
	return(ercd);

#ifdef CFG_USE_ERRORHOOK
  exit_errorhook:
	x_nested_lock_os_int();
#ifdef CFG_USE_PARAMETERACCESS
	p_ccb->_errorhook_par1.spnid = SpinlockId;
#endif /* CFG_USE_PARAMETERACCESS */
	call_errorhook(ercd, OSServiceId_ReleaseSpinlock);
	x_nested_unlock_os_int();
	goto exit_no_errorhook;
#endif /* CFG_USE_ERRORHOOK */
}

#endif /* TOPPERS_ReleaseSpinlock */

/*
 *  ԥåλ
 */
#ifdef TOPPERS_TryToGetSpinlock

StatusType
TryToGetSpinlock(SpinlockIdType SpinlockId, TryToGetSpinlockType *Success)
{
	StatusType		ercd = E_OK;
	SPNCB			*p_spncb;
	SPNCB			**pp_lastspncb;
	const SPNINIB	*p_spninib;
	CCB				*p_ccb = get_my_p_ccb();

	LOG_TRYSPN_ENTER(SpinlockId);
	S_CHECK_DISALLINT();
	CHECK_PARAM_POINTER(Success);
	CHECK_CALLEVEL(CALLEVEL_TRYTOGETSPINLOCK);
	CHECK_ID((SpinlockId != INVALID_SPINLOCK) && (SpinlockId <= tnum_spinlock));
	p_spncb = get_spncb(SpinlockId);
	CHECK_RIGHT(p_spncb->p_spninib->acsbtmp);
	CHECK_INTER_DEADLOCK(p_spncb->p_ccb != p_ccb);
	if ((p_ccb->callevel_stat & TCL_PROTECT) != 0U) {
		pp_lastspncb = (&(p_ccb->p_protectspncb));
	}
	else if (p_ccb->p_runisr != NULL) {
		pp_lastspncb = (&(p_ccb->p_runisr->p_lastspncb));
	}
	else {
		pp_lastspncb = (&(p_ccb->p_runtsk->p_lastspncb));
	}
	p_spninib = get_spninib(SpinlockId);
	CHECK_NEST_DEADLOCK(check_nest_spn_order(p_spninib, *pp_lastspncb) != FALSE);

	*Success = TRYTOGETSPINLOCK_NOSUCCESS;

	x_nested_lock_os_int();

	if (try_spn_lock(GET_SPNLOCK()) != FALSE) {
		/* ԥååǤ */
		if (p_spncb->p_holdcb == NULL) {
			/* ԥåǤ */

			/*
			 * ԥå˳߶ػߤԤϡǳ
			 * ߶ػߤԤ߶ػߤͥȲξ¤ã
			 * ˡåʤ褦ˤ뤿
			 */
			if (p_spninib->susint != NULL) {
				ercd = p_spninib->susint();
				if (ercd != E_OK) {
					release_spn_lock(GET_SPNLOCK());
					goto d_error_exit;
				}
			}

			p_spncb->p_ccb = p_ccb;
			if ((p_ccb->callevel_stat & TCL_PROTECT) != 0U) {
				p_spncb->p_holdcb = (void *) &(p_ccb->p_protectspncb);
			}
			else if (p_ccb->p_runisr != NULL) {
				p_spncb->p_holdcb = (void *) (p_ccb->p_runisr);
			}
			else {
				p_spncb->p_holdcb = (void *) (p_ccb->p_runtsk);
			}
			p_spncb->p_prevspncb = *pp_lastspncb;
			*pp_lastspncb = p_spncb;
			*Success = TRYTOGETSPINLOCK_SUCCESS;
		}
		release_spn_lock(GET_SPNLOCK());
	}

  d_exit_no_errorhook:
	x_nested_unlock_os_int();
  exit_no_errorhook:
	LOG_TRYSPN_LEAVE(ercd, Success);
	return(ercd);

#ifdef CFG_USE_ERRORHOOK
  exit_errorhook:
	x_nested_lock_os_int();
  d_exit_errorhook:
#ifdef CFG_USE_PARAMETERACCESS
	p_ccb->_errorhook_par1.spnid = SpinlockId;
	p_ccb->_errorhook_par2.tryspntype = Success;
#endif /* CFG_USE_PARAMETERACCESS */
	call_errorhook(ercd, OSServiceId_TryToGetSpinlock);
	goto d_exit_no_errorhook;
#endif /* CFG_USE_ERRORHOOK */
}
#endif /* TOPPERS_TryToGetSpinlock */
