/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2014 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: task.h 477 2014-09-26 08:55:20Z fsi-dankei $
 */

/*
 *		ǽ
 */

#ifndef TOPPERS_TASK_H
#define TOPPERS_TASK_H

#include "queue.h"
#include "resource.h"
#include "mc.h"
#include "osap.h"
#include "spinlock.h"
#include "counter.h"

/*
 *  ٥ȥޥͤ
 */
#define EVTMASK_NONE	((EventMaskType) 0) /* ٥Ȥʤ */

/*
 *  ͥͤɽ
 */
#define TPRI_MINTASK	((PriorityType) (TNUM_TPRI - 1U))               /* 㥿ͥ */
#define TPRI_MAXTASK	((PriorityType) (0))                            /* ǹ⥿ͥ */

/*
 *  IDTCBФΥޥ
 */
#define get_tcb(tskid)		(p_tcb_table[(tskid)])

/*
 *  TCB饿IDФΥޥ
 *  p_tcb NULLξϻȤʤ
 */
#define TSKID(p_tcb)	((TaskType) (((p_tcb)->p_tinib) - tinib_table))

/*
 *  ݻѿOs_Lcfg.c
 */
extern const TaskType	tnum_task;          /* ο */
extern const TaskType	tnum_exttask;       /* ĥο */


/*
 *  ֥å
 *
 *  ˴ؤͤѤʤROM֤ʬʥ
 *  ֥åˤȡͤѲ뤿RAM֤ʤФʤʤ
 *  ʬʥ֥åTCBˤʬΥTCBб륿
 *  ֥åؤݥ󥿤
 *  ֥åбTCBؤݥ󥿤ˡ
 *  RAMδ˾ޤ¹ԸΨʤ뤿˺
 *  Ƥʤ
 *  ¾Υ֥ȤˤĤƤƱͤ˰
 */
typedef struct task_initialization_block {
	FunctionRefType	task;       /* εư */

#ifdef USE_TSKINICTXB
	TSKINICTXB tskinictxb;           /* ƥȥ֥å */
#else /* USE_TSKINICTXB */
	MemorySizeType	sstksz;         /* ƥॹåΰΥʴݤ᤿͡ */
	void			*sstk;          /* ƥॹåΰΥܥȥ(SC3) */
	MemorySizeType	ustksz;         /* åΰΥʴݤ᤿͡ */
	void			*ustk;          /* åΰΥܥȥ(SC3) */
#endif /* USE_TSKINICTXB */
	OSAPCB			*p_osapcb;      /* °OSץꥱδ֥å */
	uint32			acsbtmp;        /* OSץꥱ ӥåȥޥå */
	PriorityType	inipri;         /* ͥ ɽ*/
	PriorityType	exepri;         /* ¹Գϻͥ ɽ*/
	uint8			maxact;         /* ¿ŵư׵κ */
	CCB				*p_ccb;         /* °륳֥åؤΥݥ */
	AppModeType		autoact;        /* ư⡼ */

#ifndef OMIT_STKMPUINFOB
	STKMPUINFOB	stkmpu;             /* åMPU */
#endif
} TINIB;

/*
 *  ֥åOs_Lcfg.c
 */
struct task_control_block {
	QUEUE			task_queue;     /* 塼(¤ΤƬɬ) */
	const TINIB		*p_tinib;       /* ֥åؤΥݥ */
	PriorityType	curpri;         /* ߤͥ١ɽ*/
	TaskStateType	tstat;          /* ֡ɽ*/
	uint8			actcnt;         /* ¿ŵư׵ */
	EventMaskType	curevt;         /* ٥Ȥθ */
	EventMaskType	waievt;         /* ԤäƤ륤٥ */
	RESCB			*p_lastrescb;   /* Ǹ˳꥽֥åؤΥݥ */
	CNTCB			*p_lastcntcb;   /* Ǹ󥿴֥åؤΥݥ */
	SPNCB			*p_lastspncb;   /* Ǹ˼ԥå֥åؤΥݥ */
	TSKCTXB			tskctxb;        /* ƥȥ֥å */
#ifdef CFG_USE_PROTECTIONHOOK
	boolean	calltfn;                /* ؿƤӽФե饰 */
#endif /* CFG_USE_PROTECTIONHOOK */
};

/*
 *  ֥åΥꥢkernel_mem.c
 */
extern const TINIB	tinib_table[];

/*
 *  TCBΥꥢOs_Lcfg.c
 */
extern TCB * const	p_tcb_table[];

/*
 *  ⥸塼ν
 */
extern void task_initialize(void);

/*
 *  εư
 *
 *  оݥp_tcbǻꤷˤư
 *  ʵٻ߾֤¹ԤǤ֤ܤ
 *  εưɬפʽԤ
 */
extern boolean make_active(TCB *p_tcb);

/*
 *  ¹ԤǤ֤ؤΰܹ
 *
 *  оݥp_tcbǻꤷˤ¹ԤǤ֤ܤ
 *  оݥͥ٤ǹͥ٥schedtskˤͥ٤
 *  ˤϡоݥ򿷤ǹͥ٥ȤޤǤκǹ
 *  ͥ٥ǥ塼Ƭ
 *  Ǥʤˤϡоݥǥ塼
 *  оݥǹͥ٥ȤˡTRUE ֤
 */
extern boolean make_runnable(TCB *p_tcb);

/*
 *  ¹ԤǤ֤¾ξ֤ؤ
 */
extern void make_non_runnable(CCB *p_ccb);

/*
 *  ǹ̥ͥΥ
 *
 *  ǥ塼κǹ̤ͥΥ򥵡
 *  ǥ塼ξˤϡδؿƤӽФƤϤʤʤ
 */
extern void search_schedtsk(CCB *p_ccb);

/*
 *  Υץꥨץ
 *
 *  ¹Բǽ֤˰ܹԤǹͥ٥¹Ծ֤ˤ
 *  δؿäˡdispatch ƤӽФ¾Υڤؤ
 *  ȤꤷƤ
 */
extern void preempt(CCB *p_ccb, PriorityType pre_pri);

/*
 *  ¹ΥSUSPENDED֤ˤ
 */
extern void suspend(CCB *p_ccb);

/*
 *  ꥽
 */
extern void release_taskresources(TCB *p_tcb);

/*
 *  
 */
extern void cancel_taskcounters(TCB *p_tcb);

/*
 *  ԥå
 */
extern void release_taskspinlocks(TCB *p_tcb);

/*
 *  λѥεư
 *
 *  OS߶ػ߾֤ǸƤФ
 */
extern StatusType activate_task_action(OSAPCB *p_expire_osapcb, TaskType TaskID);

/*
 *  λѥ٥ȤΥå
 *
 *  OS߶ػ߾֤ǸƤФ
 */
extern StatusType set_event_action(OSAPCB *p_expire_osapcb, TaskType TaskID, EventMaskType Mask);

/*
 *  ǥ塼饿
 */
extern void remove_task_from_queue(TCB *p_tcb, PriorityType remove_task_pri);

/*
 *  ǥ塼äƤ륿ٻ߾֤ˤ
 */
extern void suspend_ready_task(TCB *p_tcb, PriorityType remove_task_pri);

/*
 *  ζλ
 */
extern void force_terminate_task(TCB *p_tcb, StatusType terminate_cause, boolean term_osap_flag);

/*
 *  λ˸Ƥִؿ
 */
extern void exit_task(void);

/*
 *  OSAP°륿ζλ
 */
extern void force_term_osap_task(OSAPCB *p_osapcb);

#endif /* TOPPERS_TASK_H_ */
